#include"MyUtil.h"

bool isNumber(const string& token)
{
	char curChar;
	unsigned int curState = 1;
	for ( size_t index=0; index<token.size(); index++ )
	{
		curChar = token[index];
		if ( curChar=='.' && curState == 1 )
			curState = 2;
		else if ( (curChar=='%') && curState < 3 )
			curState = 3;
		else if ( ((curChar >= '0' && curChar <= '9') || curChar == '-' || curChar == ':' || curChar == '*' || curChar == '.') && (curState == 1 || curState == 2) )
			;		
		else
			return false;
	}
	return true;
}

bool isEnChar(const string& token)
{
	char curChar;
	unsigned int curState = 1;
	for ( size_t index=0; index<token.size(); index++ )
	{
		curChar = token[index];
		if ( (curChar=='.' || curChar=='-' || curChar=='_') && curState == 1 )
			curState = 2;		
		else if ( ((curChar >= 'a' && curChar <= 'z') || (curChar >= 'A' && curChar <= 'Z') || (curChar >= '0' && curChar <= '9'))
			&& (curState == 1 || curState == 2) )
			;		
		else
			return false;
	}
	return true;
}

bool isEndByPunc(const string& inputline, const string& punc)
{
	if ( inputline.empty() )
		return true;

	size_t index = inputline.length() - 3;	
	return punc.find( inputline.substr(index, 3) ) != string::npos;
}

void toLower(string& token)
{
	for (int index=0; index<(int)token.length(); index++)	
		if( token[index] >= 'A' && token[index] <= 'Z' )
			token[index] += 32;
}


////һЩȥұߵĶţȡȷĵ
void ProcQuota(string& token , int& length)
{
	if ( length == 0 )
		return;
	if (token[0]=='\"' && length > 1 && token[length-1]=='\"')//treat the " "
	{
		token=token.substr(1,token.length()-2);
		length-=2;
	}
	else if (token[0]=='\"'&&token.find_last_of('\"')==0)
	{
		token=token.substr(1,token.length()-1);
		length--;
	}
	else if (token[length-1]=='\"'&&token.find_first_of('\"')==length-1)
	{
		token=token.substr(0,token.length()-1);
		length--;
	}//ϴ˫
	else if (token[0]=='\'' && length > 1 && token[length-1]=='\'')//treat the " "
	{
		token=token.substr(1,token.length()-2);
		length-=2;
	}
	else if (token[0]=='\''&&token.find_last_of('\'')==0)
	{
		token=token.substr(1,token.length()-1);
		length--;
	}
	else if (token[length-1]=='\''&&token.find_first_of('\'')==length-1)
	{
		token=token.substr(0,token.length()-1);
		length--;
	}//ϴ
	length = (int)token.length();
};

void ProcSharp(string& token, int& length)
{
	if ( length == 0 )
		return;
	if(length > 0 && token[length-1]=='#')
	{
		token=token.substr(0,length-1);
		length--;
	}
	else if(token[0]=='#')
	{
		token=token.substr(1,length-1);
		length--;
	}
	length = (int)token.length();
};

bool Rules(string& input)
{
	int length=(int)input.length(),flen=-1;	
	do
	{
		flen=length;

		ProcQuota( input, length );		

		ProcSharp( input, length );

		if( length>0 && ( input[length-1] == '.' || input[length-1] == ',' || input[length-1] == ';' 
			|| input[length-1] == ':' || input[length-1] == '?' || input[length-1] == '\\' || input[length-1] == '/'  || input[length-1] == '!' || input[length-1] == '-') )
		{
			input=input.substr(0,length-1);
			length--;			
		}	
		length = input.length();
	}while (length!=flen && length > 0);

	if(length < 2)
		return false;

	return true;
};

string getIndex2String(int indexA, int indexB)
{
	if ( indexA<indexB )
		swap(indexA, indexB);

	char buffer[100] = {0, };
	sprintf(buffer, "%d_%d", indexA, indexB);
	return string(buffer);
}


void SplitLine(const string& inputline, const string& marker, vector<string>& container)
{
	container.clear();
	size_t leftPos = 0, rightPos = 0;
	string token;
	while ( (rightPos=inputline.find(marker, leftPos)) != string::npos )
	{
		token = inputline.substr(leftPos, rightPos-leftPos);
		leftPos = rightPos + marker.length();
		container.push_back(token);
	}
	if ( leftPos < inputline.size() )
		container.push_back( inputline.substr(leftPos) );
}

double log_sum(double log_a, double log_b)
{
	double v;

	if (log_a < log_b)
		v = log_b+log(1 + exp(log_a-log_b));
	else
		v = log_a+log(1 + exp(log_b-log_a));

	return v;
}

void L1_Norm(double* sample, int size, double alpha/* = 0*/)
{// L1 normalization with smoothing
	double sum = 0;
	int index;
	for (index=0; index<size; index++)
		sum += sample[index];
	
	sum += alpha * size;
	for (index=0; index<size; index++)
		sample[index] = (sample[index] + alpha) / sum;
}

double Digamma(double x)
{
	double p;
	x = x+6;
	p = 1/(x*x);
	p = (((0.004166666666667*p-0.003968253986254)*p+0.008333333333333)*p-0.083333333333333)*p;
	p = p+log(x)-0.5/x-1/(x-1)-1/(x-2)-1/(x-3)-1/(x-4)-1/(x-5)-1/(x-6);
	return p;
}

double KL_divergency(const double* P, const double* Q, int size)
{
	double divgergency = 0;
	for (int i=0; i<size; i++)
		divgergency += P[i] * log(P[i]/Q[i]);
	return divgergency;
}