#ifndef _MY_UNTILITY_H_
#define _MY_UNTILITY_H_

#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
using namespace std;

bool isNumber(const string& token);

bool isEnChar(const string& token);

bool isEndByPunc(const string& inputline, const string& punc);

inline double normalize(double tarCell, double tarFloor, double oriCell, double oriFloor, double value)
{
	return (value-oriFloor)/(oriCell-oriFloor)*(tarCell-tarFloor)+tarFloor;
}

void toLower(string& token);

string getIndex2String(int indexA, int indexB);

void SplitLine(const string& inputline, const string& marker, vector<string>& container);

void ProcQuota(string& token , int& length);

void ProcSharp(string& token, int& length);

bool Rules(string& input);

double log_sum(double log_a, double log_b);

void L1_Norm(double* sample, int size, double alpha = 0);

double Digamma(double x);

double KL_divergency(const double* P, const double* Q, int size);

#endif//_MY_UNTILITY_H_
