#include "_Model.h"

#ifdef _WIN32
#include "windows.h"
inline void EnableMemLeakCheck()
{
	_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG) | _CRTDBG_LEAK_CHECK_DF);
}
#endif//_WIN32

int main(int argc, const char* argv[])
{
#ifdef _WIN32
#ifdef _DEBUG	
	EnableMemLeakCheck();
#endif//_DEBUG	

	long timeTick = GetTickCount();
	_strTM model("../Data/setting.txt");

    model.LoadData("../Data/Ads/Ads_full_index.dat");
   	model.LoadCategory("../Data/Ads/Ads_full_cats.dat");
   	model.LoadSentences("../Data/Ads/Ads_full_stns.dat");
 
//    	model.LoadData("../Data/Movie/Review_index.dat");
//    	model.LoadCategory("../Data/Movie/Review_cats.dat");
//    	model.LoadSentences("../Data/Movie/Review_stns.dat");

 	model.EM_est();
	
	//model.LoadModel("../Data/Model/Ads/");
	//model.outMLTransition("../Data/Model/Ads/ML_transition.dat");

	//model.AnnotateTopicByStn("../Data/Model/Ads/topic_stns.dat");

	//model.infer("../data/Model/Ads/adDocs_infer.dat", "../data/Model/Ads/prediction.dat", 0);
	//model.inference("../Data/Ads/inference.dat");
	//model.infer4out("../Data/Ads/inference.html");
	model.eval("../Data/Ads/performance.dat");

	model.SaveModel("../Data/Model/Ads");
	timeTick = GetTickCount() - timeTick;
	cout<<"[Info]Using "<<(double)timeTick/1000<<" seconds..."<<endl;
#else//_WIN32
	if ( argc != 8 )
	{
		cerr<<"[Error]Usage: strTM settings trainingSet categoryfile stnfile modelfile inferfile prediction"<<endl;
		return 0;
	}

	_strTM model(argv[1]);
	model.LoadData(argv[2]);
	model.LoadCategory(argv[3]);
	model.LoadSentences(argv[4]);
	model.EM_est();

	//model.SaveModel(argv[5]);
	//model.inference(argv[6]);
	model.eval(argv[7]);

#endif//_WIN32

	return 0;
}