#include "priority_queue.h"

template <class _T, class _S> void _priQueue::addItem(const _T& item, const _S& score)
{
	if ( m_score.empty() )
	{
		m_score.push_back(score);
		m_storage.push_back(item);
		return;
	}

	int pos = search(score);
	if ( (int)m_score.size() < m_size )
	{
		m_score.insert(m_score.begin()+pos, score);
		m_storage.insert(m_storage.begin()+pos, item);
	}
	else if ( pos < m_size )
	{
		m_score.insert(m_score.begin()+pos, score);
		m_storage.insert(m_storage.begin()+pos, item);
		
		m_score.pop_back();
		m_storage.pop_back();
	}
}

void template <class _T, class _S> _priQueue::clear()
{
	m_size = 0;
	m_storage.clear();
	m_score.clear();
}

int template <class _T, class _S> _priQueue::binarySearch(int left, int right, const _S& score)
{
	if ( score >= m_score[left] )
		return left;
	else if ( score < m_score[right-1] )
		return right;

	int mid = (left+right)/2;
	if ( score > m_score[mid] )
		return binarySearch(left, mid, score);
	else 
		return binarySearch(mid, right, score);
}

void template <class _T, class _S> _priQueue::outItem(ofstream& fileOut)
{
	for (int i=0; i<(int)m_score.size(); i++)
		fileOut<<"\t"<<m_storage[i]<<"\t"<<m_score[i]<<endl;
}